#include <Servo.h> //this program uses the Servo library

#define SerialSpeed 9600 //typical values are 9600 or 115200
#define AnalogSenzorPIN1 4  //kde je pripojeny pravy senzor na vzdialenost
#define AnalogSenzorPIN2 5  //kde je pripojeny lavy senzor na vzdialenost
#define mapsize 1  //velkost mapy

#define line_senzor1 1 //senzor sledujuci ciaru
#define line_senzor2 2 //senzor sledujuci ciaru

/*
senzory
predny: 1.5'-12' ...0-1023 -> 4cm-30cm
zadny: 4'-31.5' ...0-1023 -> 10cm-80cm
*/

Servo LeftServo;   // lavy a pravy servo motor
Servo RightServo;

byte pole[2*mapsize][2*mapsize][4]; //mapa
boolean navsteva[2*mapsize][2*mapsize];
byte cesta[2*mapsize*2*mapsize];
int pos_x=mapsize;
int pos_y=mapsize;
byte smer=0;
int looop=0;
byte ciel[2];
byte line_data1 = 0;  
byte line_data2 = 0;
byte treshold1=190;
byte treshold2=130;

boolean test=true;

void setup() 
{
  //pinMode(13, OUTPUT); //neviem ci to tu musi alebo ma byt
  LeftServo.write(90 + 0);    // stoj
  RightServo.write(90 + 0);
  
  Serial.begin(SerialSpeed); //lebo to bolo v tutorialy
  LeftServo.attach(9);    //lavy motor v pine 9 
  RightServo.attach(10);  //pravy motor v pine 10
  
  delay(5000);
  Serial.println();
  Serial.println("Start");
  Serial.println();
}

void loop() 
{
  /*
  line_data1 = analogRead(line_senzor1);     // read the value from the sensor
  line_data2 = analogRead(line_senzor2);
  Serial.println(line_data1);
  Serial.println(line_data2);
  delay(5000);
  /**/
  /*
  otoc(1);
  delay(5000);
  otoc(-1);
  delay(20000);*/
  
  if(looop==0){
    navsteva[pos_x][pos_y]=true;
    if(test)
      Serial.print(pos_x);Serial.print(" ");Serial.print(pos_y);Serial.print(" ");
    snimaj();
    if(test)
      delay(5000);
    if(test)
      Serial.print(pos_x);Serial.print(" ");Serial.print(pos_y);Serial.print(" ");
    otoc(1);
    if(test)
      delay(5000);
    if(test)
      Serial.print(pos_x);Serial.print(" ");Serial.print(pos_y);Serial.print(" ");
    snimaj();
    if(test)
      delay(5000);
  }
  
  
  novy_ciel(ciel);
  if(test){
    Serial.print("ciel: [");
    Serial.print(ciel[0]);
    Serial.print(", ");
    Serial.print(ciel[1]);
    Serial.print("]");
    Serial.println();
  }
  if(ciel[0]==255 && ciel[1]==255){
    Serial.println( "Bludisko zmapovane:" );
    for(int i=0;i<mapsize*2;i++){ //vypis pole
      for(int j=0; j<mapsize*2;j++){
        Serial.print( pole[i][j][0] );
        Serial.print( pole[i][j][1] );
        Serial.print( pole[i][j][2] );
        Serial.print( pole[i][j][3] );
        Serial.print( " " );
      }
      Serial.println();
    }
    Serial.println();
    Serial.println("Zadajte suradnice bodov A a B a smer robota");
    delay(20000);
    int ax,bx,ay,by;
    ax=Serial.read();pos_x=ax;
    ay=Serial.read();pos_y=by;
    bx=Serial.read();
    by=Serial.read();
    smer=Serial.read();
    hladat_cestu(ax, ay, bx, by, cesta);
    if(cesta[0]==0){
      Serial.println("Cesta k cielu neexistuje");
    }else{
      for(int i=cesta[0]-1; i>0; i--){
        if(cesta[i]==smer){
          if(test)
            Serial.print(pos_x);Serial.print(" ");Serial.print(pos_y);Serial.print(" ");
          vpred();
          if(test)
            delay(5000);
        }else if(cesta[i]==(smer+2)%4){
          if(test)
            Serial.print(pos_x);Serial.print(" ");Serial.print(pos_y);Serial.print(" ");
          otoc(1);
          if(test)
            delay(5000);
          if(test)
            Serial.print(pos_x);Serial.print(" ");Serial.print(pos_y);Serial.print(" ");
          otoc(1);
          if(test)
            delay(5000);
          if(test)
            Serial.print(pos_x);Serial.print(" ");Serial.print(pos_y);Serial.print(" ");
          vpred();
          if(test)
            delay(5000);
        }else if(cesta[1]==(smer+1)%4){
          if(test)
            Serial.print(pos_x);Serial.print(" ");Serial.print(pos_y);Serial.print(" ");
          otoc(1);
          if(test)
            delay(5000);
          if(test)
            Serial.print(pos_x);Serial.print(" ");Serial.print(pos_y);Serial.print(" ");
          vpred();
          if(test)
            delay(5000);
        }else if(cesta[1]==(smer+3)%4){
          if(test)
            Serial.print(pos_x);Serial.print(" ");Serial.print(pos_y);Serial.print(" ");
          otoc(-1);
          if(test)
            delay(5000);
          if(test)
            Serial.print(pos_x);Serial.print(" ");Serial.print(pos_y);Serial.print(" ");
          vpred();
          if(test)
            delay(5000);
        }
      }
    }
    Serial.println("Som v cieli koncim");
    for(;;);
  }else{
    hladat_cestu(pos_x, pos_y, ciel[0], ciel[1], cesta);
    if(cesta[0]==0){
      Serial.println("Cesta k cielu neexistuje");
    }else{
      //Serial.println("Cesta k cielu existuje");
      //Serial.println(cesta[0]);
      for(int i=cesta[0]-1; i>0; i--){
        if(cesta[i]==smer){
          if(test)
            Serial.print(pos_x);Serial.print(" ");Serial.print(pos_y);Serial.print(" ");
          vpred();
          if(test)
            delay(5000);
        }else if(cesta[i]==(smer+2)%4){
          if(test)
            Serial.print(pos_x);Serial.print(" ");Serial.print(pos_y);Serial.print(" ");
          otoc(1);
          if(test)
            delay(5000);
          if(test)
            Serial.print(pos_x);Serial.print(" ");Serial.print(pos_y);Serial.print(" ");
          otoc(1);
          if(test)
            delay(5000);
          if(test)
            Serial.print(pos_x);Serial.print(" ");Serial.print(pos_y);Serial.print(" ");
          vpred();
          if(test)
            delay(5000);
        }else if(cesta[i]==(smer+1)%4){
          if(test)
            Serial.print(pos_x);Serial.print(" ");Serial.print(pos_y);Serial.print(" ");
          otoc(1);
          if(test)
            delay(5000);
          if(test)
            Serial.print(pos_x);Serial.print(" ");Serial.print(pos_y);Serial.print(" ");
          vpred();
          if(test)
            delay(5000);
        }else if(cesta[i]==(smer+3)%4){
          if(test)
            Serial.print(pos_x);Serial.print(" ");Serial.print(pos_y);Serial.print(" ");
          otoc(-1);
          if(test)
            delay(5000);
          if(test)
            Serial.print(pos_x);Serial.print(" ");Serial.print(pos_y);Serial.print(" ");
          vpred();
          if(test)
            delay(5000);
        }
      }
      if(ciel[0]==pos_x && ciel[1]==pos_y){
        if(test)
          Serial.print(pos_x);Serial.print(" ");Serial.print(pos_y);Serial.print(" ");
        snimaj();
        if(test)
          delay(5000);
        if(test)
          Serial.print(pos_x);Serial.print(" ");Serial.print(pos_y);Serial.print(" ");
        otoc(1);
        if(test)
          delay(5000);
        if(test)
          Serial.print(pos_x);Serial.print(" ");Serial.print(pos_y);Serial.print(" ");
        snimaj();
        if(test)
          delay(5000);
      }
    }
  }/**/
  
  /*
  // testy
  Serial.println("Maze:");
  for(int i=0;i<mapsize*2;i++){ //test co je v poli
    for(int j=0; j<mapsize*2;j++){
      Serial.print( pole[i][j][0] );
      Serial.print( pole[i][j][1] );
      Serial.print( pole[i][j][2] );
      Serial.print( pole[i][j][3] );
      Serial.print( " " );
    }
    Serial.println();
  }
  Serial.println();
  
  Serial.println("Navsteva:");
  for(int i=0;i<mapsize*2;i++){ //test co je v poli
    for(int j=0; j<mapsize*2;j++){
      Serial.print( navsteva[i][j] );
      Serial.print( " " );
    }
    Serial.println();
  }*/
  //Serial.println();
  //delay(10000);/**/
  
  delay(3000);
  
 //for(;;);
 looop++;
}

/* vystavajnie cesty*/
void hladat_cestu(int zx, int zy, int cx, int cy, byte *cesta){
  if(test)
    Serial.print( "Hladam cestu k cielu " );
  int aktx=zx,akty=zy;
  byte pozicia=0;
  byte pocet=0;
  byte queue[mapsize*2*mapsize*2][2];
  char visited[mapsize*2][mapsize*2];
  
  for(int i=0;i<mapsize*2;i++){ //test co je v poli
    for(int j=0; j<mapsize*2;j++){
      (visited[i][j])=0;
    }
  }
  
  visited[zx][zy]=zx*10+zy+1;
  queue[0][0]=zx;
  queue[0][1]=zy;
  pocet++;
  while(pocet>0){
    byte aktx=queue[pozicia][0];
    byte akty=queue[pozicia][1];
    pocet--;
    pozicia++;
    if(visited[aktx][akty]>0){
      visited[aktx][akty]*=-1;
      if(aktx==cx && akty==cy){
        break;
      }
      
      if(pole[aktx][akty][0]==2){
        if(akty>0 && visited[aktx][akty-1]==0){
          queue[pozicia+pocet][0]=aktx;
          queue[pozicia+pocet][1]=akty-1;
          pocet++;
          visited[aktx][akty-1]=10*aktx+akty+1;
        }
      }
      if(pole[aktx][akty][1]==2){
        if(aktx>0 && visited[aktx-1][akty]==0){
          queue[pozicia+pocet][0]=aktx-1;
          queue[pozicia+pocet][1]=akty;
          pocet++;
          visited[aktx-1][akty]=10*aktx+akty+1;
        }
      }
      if(pole[aktx][akty][2]==2){
        if(akty<mapsize*2-1 && visited[aktx][akty+1]==0){
          queue[pozicia+pocet][0]=aktx;
          queue[pozicia+pocet][1]=akty+1;
          pocet++;
          visited[aktx][akty+1]=10*aktx+akty+1;
        }
      }
      if(pole[aktx][akty][3]==2){
        if(aktx<mapsize*2-1 && visited[aktx+1][akty]==0){
          queue[pozicia+pocet][0]=aktx+1;
          queue[pozicia+pocet][1]=akty;
          pocet++;
          visited[aktx+1][akty]=10*aktx+akty+1;
        }
      }
    }
  }
  
  aktx=cx;
  akty=cy;
  if(visited[aktx][akty]==0){
    cesta[0]=0;
  }else{
    pocet=1;
    while(visited[aktx][akty]!=(10*aktx+akty+1)*-1){
      if(visited[aktx][akty]==(aktx*10+akty+1)*-1-10){
        cesta[pocet]=1; //smer 3 - hore
      }else if(visited[aktx][akty]==(aktx*10+akty+1)*-1+10){
        cesta[pocet]=3; //smer 1 - dole
      }else if(visited[aktx][akty]==(aktx*10+akty+1)*-1-1){
        cesta[pocet]=0; //smer 0 - vlavo
      }else if(visited[aktx][akty]==(aktx*10+akty+1)*-1+1){
        cesta[pocet]=2; //smer 2 - vpravo
      }
      pocet++;
      pozicia=((visited[aktx][akty]*-1)-1)%10;
      aktx=((visited[aktx][akty]*-1)-1)/10;
      akty=pozicia;
    }
    cesta[0]=pocet;
  }
  if(test)
    Serial.println( "- hotovo" );
}


/* pohlada pole v ktorom este nebol */
void novy_ciel(byte *ciel){
  if(test)
    Serial.print( "Hladam ciel " );
  for(int i=0;i<mapsize*2;i++){
    for(int j=0; j<mapsize*2;j++){
      if( navsteva[pos_x][pos_y]==true){
        if(pole[i][j][0]==2 && j>0 && navsteva[i][j-1]==false){
          ciel[0]=i;
          ciel[1]=j-1;
          if(test)
            Serial.println( "- hotovo" );
          return;
        }
        if(pole[i][j][1]==2 && i>0 && navsteva[i-1][j]==false){
          ciel[0]=i-1;
          ciel[1]=j;
          if(test)
            Serial.println( "- hotovo" );
          return;
        }
        if(pole[i][j][2]==2 && j<mapsize*2 && navsteva[i][j+1]==false){
          ciel[0]=i;
          ciel[1]=j+1;
          if(test)
            Serial.println( "- hotovo" );
          return;
        }
        if(pole[i][j][3]==2 && i<mapsize*2 && navsteva[i+1][j]==false){
          ciel[0]=i+1;
          ciel[1]=j;
          if(test)
            Serial.println( "- hotovo" );
          return;
        }
      }
    }
  }
  ciel[0]=255;
  ciel[1]=255;
  if(test)
    Serial.println( "- hotovo" );
}

/* zisti ci su v okoli prekazky */
void snimaj(){
  if(test)
    Serial.print( "Snimam " );
  int senzor1=analogRead(AnalogSenzorPIN1); //GP2D120
  int senzor2=analogRead(AnalogSenzorPIN2); //2Y0A21
  if(senzor1>200){
    pole[pos_x][pos_y][(smer+1)%4]=1;
  }else{
    pole[pos_x][pos_y][(smer+1)%4]=2;
  }
  
  if(senzor2>300){
    pole[pos_x][pos_y][(smer+3)%4]=1;
  }else{
    pole[pos_x][pos_y][(smer+3)%4]=2;
  }
  if(test)
    Serial.println( "- hotovo" );
}


/* otoci sa doprava kam==1 alebo dolava kam!=1 */
void otoc(int kam){
  if(kam==1){
    if(test)
      Serial.print( "Otacam sa vpravo" );
    smer++;
    if(smer==4){
      smer=0;
    }
  }else{
    if(test)
      Serial.print( "Otacam sa vlavo" );
    smer--;
    if(smer==-1){
      smer=3;
    }
  }
  
  while(true){
    line_data1 = analogRead(line_senzor1);     // read the value from the sensor
    line_data2 = analogRead(line_senzor2);
    if(line_data1<treshold1 && line_data2>treshold2){
      left();
    }else if(line_data1>treshold1 && line_data2<treshold2){
      right();
    }else if(line_data1<treshold1 && line_data2<treshold2){
      bw();
    }else if(line_data1>treshold1 && line_data2>treshold2){
      break;
    }
  }
  if(kam==1){
    right();right();right();right();right();right();
  }else{
    left();left();left();left();left();left();
  }
  
  for(int i=0; i<3; i++){
    line_data1 = analogRead(line_senzor1);     // read the value from the sensor
    line_data2 = analogRead(line_senzor2);
    if(line_data1<treshold1 && line_data2<treshold2){
      fw();
    }else if(line_data1>treshold1 && line_data2<treshold2){
      right();i--;
    }else if(line_data1<treshold1 && line_data2>treshold2){
      left();i--;
    }else if(line_data1>treshold1 && line_data2>treshold2){
      fw();
    }
  }
  if(test)
    Serial.println( "- hotovo" );
}

/* prejde o jedno pole vpred */
void vpred(){
  if(test)
    Serial.print( "Idem vpred " );
  boolean pom=true;
  if(smer==0 && pos_y>0){
    pos_y--;
  }else if(smer==1 && pos_x>0){
    pos_x--;
  }else if(smer==2 && pos_y<2*mapsize){
    pos_y++;
  }else if(smer==3 && pos_x<2*mapsize){
    pos_x++;
  }else{
    pom=false;
  }
  if(pom){
    navsteva[pos_x][pos_y]=true;
    
    while(true){
      line_data1 = analogRead(line_senzor1);     // read the value from the sensor
      line_data2 = analogRead(line_senzor2);
      if(line_data1<treshold1 && line_data2>treshold2){
        right();
      }else if(line_data1>treshold1 && line_data2<treshold2){
        left();
      }else if(line_data1<treshold1 && line_data2<treshold2){
        fw();
      }else if(line_data1>treshold1 && line_data2>treshold2){
        break;
      }
    }
    fw();fw();fw();
  }
  if(test)
    Serial.println( "- hotovo" );
}

/* krok vpred */
void fw(){
  LeftServo.write(90 - 2);    // go forward
  RightServo.write(90 + 2);           
  delay(350);
  LeftServo.write(90 + 0);    // stoj
  RightServo.write(90 + 0); 
}

/* krok vzad */
void bw(){
  LeftServo.write(90 + 2);    // go forward
  RightServo.write(90 - 2);           
  delay(350);
  LeftServo.write(90 + 0);    // stoj
  RightServo.write(90 + 0); 
}

/* krok vlavo */
void left(){
  LeftServo.write(90 - 2);    // rotate left
  RightServo.write(90 - 2);
  delay(400);
  LeftServo.write(90 + 0);    // stoj
  RightServo.write(90 + 0);
}

/* krok vpravo */
void right(){
  LeftServo.write(90 + 2);    // rotate right
  RightServo.write(90 + 2);
  delay(400);
  LeftServo.write(90 + 0);    // stoj
  RightServo.write(90 + 0); 
}
